#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "term.h"

#ifdef QDOS
#include <qdos.h>
char _prog_name[] = "tput";
char _version[]   = " v1.00 ";
char _copyright[]  = "(c)1991-1994  K.D.Walker";
void (*_consetup)() = consetup_title;           /* Fancy titled screen */
#endif /* QDOS */

int optind = 1;

void
usage(char *progname)
{
  fprintf(stderr, "usage: %s [capname [params]]\n", progname);
  exit(1);
}

int
main(int argc, char *argv[])
{
  long param1 = 0;
  long param2 = 0;
  long param3 = 0;
  long param4 = 0;
  long param5 = 0;
  long param6 = 0;
  long param7 = 0;
  long param8 = 0;
  long param9 = 0;
  int flag;
  int num;
  char *str;
  char *capname;

  if(optind >= argc) usage(argv[0]);

  setupterm((char *)0, 1, (int *)0);

  capname = argv[optind++];

  if(strcmp(capname, "reset") == 0)
    {
    if(reset_1string) fputs(reset_1string,stdout);
    if(reset_2string) fputs(reset_2string,stdout);
    if(reset_3string) fputs(reset_3string,stdout);
    }
  else if(strcmp(capname, "init") == 0)
    {
    if(init_1string) fputs(init_1string,stdout);
    if(init_2string) fputs(init_2string,stdout);
    if(clear_margins) fputs(clear_margins,stdout);
    if(set_left_margin) fputs(set_left_margin,stdout);
    if(set_right_margin) fputs(set_right_margin,stdout);
    if(clear_all_tabs) fputs(clear_all_tabs,stdout);
    if(set_tab)
      {
      int  x;

      if(carriage_return) fputs(carriage_return,stdout);
      for (x = 0; x < columns; x++)
        {
        if((x % init_tabs) == 0) fputs(set_tab,stdout);
        else fputs(" ",stdout);
        }
      }
    if(init_3string) fputs(init_3string,stdout);
    if(orig_colors) fputs(orig_colors,stdout);
    if(orig_pair) fputs(orig_pair,stdout);
    }
  else if(strcmp(capname, "longname") == 0)
    {
      for(str=cur_term->_termdesc+strlen(cur_term->_termdesc);*(--str)!='|';)
          ;
      puts(str+1);
    }
  else
    {
    if(optind < argc) param1 = atol(argv[optind++]);
    if(optind < argc) param2 = atol(argv[optind++]);
    if(optind < argc) param3 = atol(argv[optind++]);
    if(optind < argc) param4 = atol(argv[optind++]);
    if(optind < argc) param5 = atol(argv[optind++]);
    if(optind < argc) param6 = atol(argv[optind++]);
    if(optind < argc) param7 = atol(argv[optind++]);
    if(optind < argc) param8 = atol(argv[optind++]);
    if(optind < argc) param9 = atol(argv[optind++]);
  
    if((flag = tigetflag(capname)) != -1) printf("%d\n", flag);
    else if((num = tigetnum(capname)) != -2) printf("%d\n", num);
    else if((str = tigetstr(capname)) == (char *)-1 || str == (char *)-2)
      {
      fprintf(stderr,
              "%s: unknown terminal capability '%s'\n", argv[0], capname);
      exit(1);
      }
    else if(str)
      {
      if(argc > 2)
        str = tparm(str, param1, param2, param3, param4, param5, param6, param7, param8, param9);
      fputs(str,stdout);
      }
    }
  return(0);
}
